Wednesday, August 24, 2016

388. Longest Absolute File Path

I really struggled to make the code concise and short, but could not. I guess sticking with an understandable solution will hopefully later leads to more concise code.

A mistake to come up a solution is to forget to add a clash into the absolute path.
Suppose we abstract our file system by a string in the following manner:
The string "dir\n\tsubdir1\n\tsubdir2\n\t\tfile.ext" represents:
dir
    subdir1
    subdir2
        file.ext
The directory dir contains an empty sub-directory subdir1 and a sub-directory subdir2 containing a file file.ext.
The string "dir\n\tsubdir1\n\t\tfile1.ext\n\t\tsubsubdir1\n\tsubdir2\n\t\tsubsubdir2\n\t\t\tfile2.ext" represents:
dir
    subdir1
        file1.ext
        subsubdir1
    subdir2
        subsubdir2
            file2.ext
The directory dir contains two sub-directories subdir1 and subdir2subdir1 contains a file file1.ext and an empty second-level sub-directory subsubdir1subdir2 contains a second-level sub-directory subsubdir2 containing a file file2.ext.
We are interested in finding the longest (number of characters) absolute path to a file within our file system. For example, in the second example above, the longest absolute path is"dir/subdir2/subsubdir2/file2.ext", and its length is 32 (not including the double quotes).
Given a string representing the file system in the above format, return the length of the longest absolute path to file in the abstracted file system. If there is no file in the system, return0.
Note:
  • The name of a file contains at least a . and an extension.
  • The name of a directory or sub-directory will not contain a ..
Time complexity required: O(n) where n is the size of the input string.
Notice that a/aa/aaa/file1.txt is not the longest file path, if there is another path aaaaaaaaaaaaaaaaaaaaa/sth.png.

 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
public class Solution {
    public int lengthLongestPath(String input) {
        //sequencially going through all the paths and files,
        //not care about the empty dirs because only file contribute to file path length
        String[] dirs = input.split("\n");//parse out each directory
        Stack<Integer> lvls= new Stack<Integer>();
        
        int maxLen = 0;
        for(String s:dirs){
            int lev = s.lastIndexOf("\t");
            if(lev==-1){//this must be direct children in root dir
                lvls.clear();
                lvls.push(s.length()+1);//every push is a path, and +1 for a slash
            }
            else{
                //for subdirs or files
                //want to retreat back to parent level
                while(lvls.size()>lev+1)lvls.pop();
                //lvl is -1, 0,1 etc, with 0 means first sublevel. because when its size is greater than lvl, 
                //it will go further to reduce one, so lev+1 make sure it stops at parent level/lev after the further reduction
                lvls.push(lvls.peek()+s.length()-(lev+1)+1);//lev+1 is number if "\t"
                
            }
            if(s.contains(".")) maxLen = Math.max(maxLen, lvls.peek()-1);//file is not ended with a slash
        }
        return maxLen;
    }
}

387. First Unique Character in a String

This is very similar to the second question I was asked in an Amazon interview back to 2014. Here's my solution for it.
Given a string, find the first non-repeating character in it and return it's index. If it doesn't exist, return -1.
Examples:
s = "leetcode"
return 0.

s = "loveleetcode",
return 2.
Note: You may assume the string contain only lowercase letters.


 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
public class Solution {
    public int firstUniqChar(String s) {
        if(s==null ||s.length()==0)return -1;
        if(s.length()==1)return 0;
        
        int[] positions = new int[26];
        for(int i=0;i<26;i++){
            positions[i]=Integer.MIN_VALUE;
        }
        //set repeated ones with -1
        for(int i=0;i<s.length();i++){
            int curCharIndex = s.charAt(i)-'a';
            if(positions[curCharIndex]==Integer.MIN_VALUE){
                positions[curCharIndex]=i;
            }else if(positions[curCharIndex]>=0){
                positions[curCharIndex]=-1;
            }
        }
        for(int i=0;i<s.length();i++){
            int curCharIndex = s.charAt(i)-'a';
            if(positions[curCharIndex]>=0){
                return positions[curCharIndex];
            }
        }
        return -1;
    }
}

Thursday, August 11, 2016

A tip on inheritence

if a class has two method overloaded with parameters with inheritance relationships, when method is invokded with different type of objects, the method with up most parent class will be invoked.



public class A {
 String getV(){
return "A";
 }
}


public class B extends A {
String getV(){
return "B";
}
public static void test(A a){
System.out.println(a.getV());
}
public static void test(B b){
System.out.println(b.getV());
}
public static void main(String[] arg){
A a = new A();
A b = new B();
test(b);
test(a);
}
}

In the testing, only test(A a ) will be invoked.

Wednesday, August 03, 2016

Search in a big sorted array

Given a big sorted array with positive integers sorted by ascending order. The array is so big so that you can not
get the length of the whole array directly, and you can only access the kth number by ArrayReader.get(k)
(or ArrayReader->get(k) for C++). Find the first index of a target number. Your algorithm should be in O(log k),
where k is the first index of the target number.

Return -1, if the number doesn’t exist in the array.

It is still binary search, but how to start if we do not know the length?
Since there is a function t get kth element, we can do binary increase the first until we found a k whose element
is greater than target. we can then do normal binary search up to the k position.



 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
int binarySearch(int target){
 int len = 1;
 while (ArrayReader.get(len - 1) < target){
  len *= 2;
 }
 int low = 0, high = len - 1;//now we are working on 0 based index
 while (low <= high){
  int mid = (low + high) / 2;
  int num = ArrayReader.get(mid);
  if (num <target) low = mid+1;
  else if(num>target)high = mid-1;
  else return mid;
 }
 
 return -1;
 
}